;M.GRAZIANI - GONG - 2013

	sr = 44100
	kr = 4410
	ksmps = 10
	nchnls = 2


gafilt	init	0			; filter input global var

; input signals

	strset	1,"mygong.wav"
	strset	2,"g1oct.aiff"
	strset	3,"g2oct.aiff"
	strset	4,"g2.54716.aiff"
	strset	5,"g4.554619.aiff"
	strset	6,"g7.363529.aiff"
	strset	7,"g10.80612.aiff"
	strset	10,"mygong-reversed.wav"
	strset	11,"g-all-cvoice.wav"

;	I01 - Singolo Osc x additiva o fascie
; p4	ampiezza
; p5	frequenza
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	fase (opzionale)
; p10	compensatore ampiezza (p4*p10)
; p11	stereo pos


	instr 1

ileft	=	p11
iright	=	1-p11

ifreq   =       p5                      ; freq normalmente in cps
        if      p5 >= 20 igoto icps     ; se >= 20 resta in cps
ifreq   =       cpspch(p5)              ; altrimenti convertiamo in cps da pch

icps:
iamp	=	p4*p10			; amp normalmente assoluta
;        if      p4 > 91 igoto inorm	; se > 91 resta assoluta
;iamp   =       ampdb(p4)	 	; altrimenti convertiamo in ass da db

inorm:
kamp	linen		iamp, p7, p3, p8
aout	oscil		kamp, ifreq, p6, p9
	outs		aout*ileft,aout*iright
	endin


;	I02 - Singolo Osc x additiva o fascie con ring alla fine
; p4	ampiezza
; p5	frequenza
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	fase (opzionale)
; p10	ring freq
; p11	ring func
; p12	stereo

	instr 2
ileft	=	p12
iright	=	1-p12

ifreq   =       p5                      ; freq normalmente in cps
        if      p5 >= 20 igoto icps     ; se >= 20 resta in cps
ifreq   =       cpspch(p5)              ; altrimenti convertiamo in cps da pch

icps:
iamp	=	p4			; amp normalmente assoluta
;        if      p4 > 91 igoto inorm	; se > 91 resta assoluta
;iamp   =       ampdb(p4)	 	; altrimenti convertiamo in ass da db

inorm:
kamp	linen		iamp, p7, p3, p8
asig	oscil		kamp, ifreq, p6, p9
aout	oscil		asig, p10, p11, 0
	outs		aout*ileft,aout*iright
	endin


;	I03 - 7 Osc x additiva con freq ratio e amp ratio da func
; p4	ampiezza (will be p4*table)
; p5	frequenza (will be p5*table)
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	fase (opzionale)
; p10	compensatore ampiezza (p4*p9)
; p11	table funa freq
; p12	table funa amp
; p13	stereo
; p14	0 = normal out, > 0 = to gafilt * p14

	instr 3

ileft	=	p13
iright	=	1-p13

itf1	table 0, p11
if1	=       itf1*p5			; freq normalmente in cps
itf2	table 1, p11
if2	=       itf2*p5			; freq normalmente in cps
itf3	table 2, p11
if3	=       itf3*p5			; freq normalmente in cps
itf4	table 3, p11
if4	=       itf4*p5			; freq normalmente in cps
itf5	table 4, p11
if5	=       itf5*p5			; freq normalmente in cps
itf6	table 5, p11
if6	=       itf6*p5			; freq normalmente in cps
itf7	table 6, p11
if7	=       itf7*p5			; freq normalmente in cps

ita1	table 0, p12
ia1	=       ita1*p4*p10
ita2	table 1, p12
ia2	=       ita2*p4*p10
ita3	table 2, p12
ia3	=       ita3*p4*p10
ita4	table 3, p12
ia4	=       ita4*p4*p10
ita5	table 4, p12
ia5	=       ita5*p4*p10
ita6	table 5, p12
ia6	=       ita6*p4*p10
ita7	table 6, p12
ia7	=       ita7*p4*p10

;print if1,if2,if3,if4,if5,if6,if7
;print ia1,ia2,ia3,ia4,ia5,ia6,ia7

kamp	linen		1, p7, p3, p8
a1	oscil		kamp*ia1, if1, p6, p9
a2	oscil		kamp*ia2, if2, p6, p9
a3	oscil		kamp*ia3, if3, p6, p9
a4	oscil		kamp*ia4, if4, p6, p9
a5	oscil		kamp*ia5, if5, p6, p9
a6	oscil		kamp*ia6, if6, p6, p9
a7	oscil		kamp*ia7, if7, p6, p9

aout	=		a1+a2+a3+a4+a5+a6+a7

	if	p14 > 0 goto afilt
	outs		aout*ileft,aout*iright
	goto	aend
afilt:
gafilt	=	gafilt + aout * p14
aend:
	endin


;	I04 - Come I03 ma con exp att,dec
; p4	ampiezza (will be p4*table)
; p5	frequenza (will be p5*table)
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	fase (opzionale)
; p10	compensatore ampiezza (p4*p9)
; p11	table funa freq
; p12	table funa amp
; p13	stereo

	instr 4

ileft	=	p13
iright	=	1-p13

itf1	table 0, p11
if1	=       itf1*p5			; freq normalmente in cps
itf2	table 1, p11
if2	=       itf2*p5			; freq normalmente in cps
itf3	table 2, p11
if3	=       itf3*p5			; freq normalmente in cps
itf4	table 3, p11
if4	=       itf4*p5			; freq normalmente in cps
itf5	table 4, p11
if5	=       itf5*p5			; freq normalmente in cps
itf6	table 5, p11
if6	=       itf6*p5			; freq normalmente in cps
itf7	table 6, p11
if7	=       itf7*p5			; freq normalmente in cps

ita1	table 0, p12
ia1	=       ita1*p4*p10
ita2	table 1, p12
ia2	=       ita2*p4*p10
ita3	table 2, p12
ia3	=       ita3*p4*p10
ita4	table 3, p12
ia4	=       ita4*p4*p10
ita5	table 4, p12
ia5	=       ita5*p4*p10
ita6	table 5, p12
ia6	=       ita6*p4*p10
ita7	table 6, p12
ia7	=       ita7*p4*p10

itaba	=	p14
	if	itaba != 0 igoto itaba1
itaba	=	99
itaba1:

iz1	table 0, itaba
iat1z1	=	p7*iz1
iat2z1	=	p7-iat1z1
idc2z1	=	p8*iz1
idc1z1	=	p8-idc2z1
iz2	table 1, itaba
iat1z2	=	p7*iz2
iat2z2	=	p7-iat1z2
idc2z2	=	p8*iz2
idc1z2	=	p8-idc2z2
iz3	table 2, itaba
iat1z3	=	p7*iz3
iat2z3	=	p7-iat1z3
idc2z3	=	p8*iz3
idc1z3	=	p8-idc2z3
iz4	table 3, itaba
iat1z4	=	p7*iz4
iat2z4	=	p7-iat1z4
idc2z4	=	p8*iz4
idc1z4	=	p8-idc2z4
iz5	table 4, itaba
iat1z5	=	p7*iz5
iat2z5	=	p7-iat1z5
idc2z5	=	p8*iz5
idc1z5	=	p8-idc2z5
iz6	table 5, itaba
iat1z6	=	p7*iz6
iat2z6	=	p7-iat1z6
idc2z6	=	p8*iz6
idc1z6	=	p8-idc2z6
iz7	table 6, itaba
iat1z7	=	p7*iz7
iat2z7	=	p7-iat1z7
idc2z7	=	p8*iz7
idc1z7	=	p8-idc2z7

isust	=	p3-p7-p8

ka1	expseg		.01, p7, 1,  p3-p7-p8, 1, p8, .01
a1	oscil		ka1*ia1, if1, p6, p9
a2	oscil		ka1*ia2, if2, p6, p9
a3	oscil		ka1*ia3, if3, p6, p9
a4	oscil		ka1*ia4, if4, p6, p9
a5	oscil		ka1*ia5, if5, p6, p9
a6	oscil		ka1*ia6, if6, p6, p9
a7	oscil		ka1*ia7, if7, p6, p9

aout	=		a1+a2+a3+a4+a5+a6+a7
	outs		aout*ileft,aout*iright
	endin


;	I05 - Come I03 con loscil
; p4	ampiezza (will be p4*table)
; p5	frequenza (will be p5*table)
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	fase (opzionale)
; p10	compensatore ampiezza (p4*p9)
; p11	table funa freq
; p12	table funa amp
; p13	stereo
; p14	0 = normal out, > 0 = to gafilt * p14
; Nota: ibas  letto in fun 69 nella loc data da p6-70 (usare fun = p6 >= 70


	instr 5

ileft	=	p13
iright	=	1-p13

itf1	table 0, p11
if1	=       itf1*p5			; freq normalmente in cps
itf2	table 1, p11
if2	=       itf2*p5			; freq normalmente in cps
itf3	table 2, p11
if3	=       itf3*p5			; freq normalmente in cps
itf4	table 3, p11
if4	=       itf4*p5			; freq normalmente in cps
itf5	table 4, p11
if5	=       itf5*p5			; freq normalmente in cps
itf6	table 5, p11
if6	=       itf6*p5			; freq normalmente in cps
itf7	table 6, p11
if7	=       itf7*p5			; freq normalmente in cps

ita1	table 0, p12
ia1	=       ita1*p4*p10
ita2	table 1, p12
ia2	=       ita2*p4*p10
ita3	table 2, p12
ia3	=       ita3*p4*p10
ita4	table 3, p12
ia4	=       ita4*p4*p10
ita5	table 4, p12
ia5	=       ita5*p4*p10
ita6	table 5, p12
ia6	=       ita6*p4*p10
ita7	table 6, p12
ia7	=       ita7*p4*p10

ibas	table p6-70, 69

print ibas
;print if1,if2,if3,if4,if5,if6,if7
;print ia1,ia2,ia3,ia4,ia5,ia6,ia7

kamp	linen		1, p7, p3, p8
a1	loscil		kamp*ia1, if1, p6, ibas, 1
a2	loscil		kamp*ia2, if2, p6, ibas, 1
a3	loscil		kamp*ia3, if3, p6, ibas, 1
a4	loscil		kamp*ia4, if4, p6, ibas, 1
a5	loscil		kamp*ia5, if5, p6, ibas, 1
a6	loscil		kamp*ia6, if6, p6, ibas, 1
a7	loscil		kamp*ia7, if7, p6, ibas, 1

aout	=		a1+a2+a3+a4+a5+a6+a7

	if	p14 > 0 goto afilt
	outs		aout*ileft,aout*iright
	goto	aend
afilt:
gafilt	=	gafilt + aout * p14
aend:
	endin

;	I10	read normal
; p4	amp (1)
; p5	# file
; p6	skip time
; p7-p8	att, dec
; p9	stereo

	instr		10				; read normal
ileft	=		p9
iright	=		1-p9
kamp	linen		p4, p7, p3, p8
asig	soundin		p5, p6
aout	= 		asig*kamp
	outs		aout*ileft,aout*iright
	endin

;	I11 - Onde lette da loscil
; p4	ampiezza
; p5	frequenza
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	stereo
; p10	0 = normal out, > 0 = to gafilt * p10
; Nota: ibas  letto in fun 69 nella loc data da p6-70 (usare fun = p6 >= 70


	instr 11

ileft	=	p9
iright	=	1-p9

ibas	table p6-70, 69

kamp	linen		p4, p7, p3, p8
a1	loscil3		kamp, p5, p6, ibas, 1


	if	p10 > 0 goto afilt
	outs		a1*ileft,a1*iright
	goto	aend
afilt:
gafilt	=	gafilt + a1 * p10
aend:
	endin


;	I12 - Come I11 con env exp
; p4	ampiezza (will be p4*table)
; p5	frequenza (will be p5*table)
; p6	num funzione audio
; p7	attacco (exp)
; p8	decay (exp)
;	NB: p7+p8 <= P3
; p9	stereo
; p10	0 = normal out, > 0 = to gafilt * p10
; Nota: ibas  letto in fun 69 nella loc data da p6-70 (usare fun = p6 >= 70


	instr 12

ileft	=	p9
iright	=	1-p9

ibas	table p6-70, 69

kamp	expseg		.001, p7, 1,  p3-p7-p8, 1, p8, .001
a1	loscil3		kamp*p4, p5, p6, ibas, 1


	if	p10 > 0 goto afilt
	outs		a1*ileft,a1*iright
	goto	aend
afilt:
gafilt	=	gafilt + a1 * p10
aend:
	endin


;	I13 - Come I11 ma doppiate a dist p11
; p4	ampiezza (will be p4*table)
; p5	frequenza (will be p5*table)
; p6	num funzione audio
; p7	attacco (lineare)
; p8	decay (lineare)
;	NB: p7+p8 <= P3
; p9	stereo
; p10	0 = normal out, > 0 = to gafilt * p10
; Nota: ibas  letto in fun 69 nella loc data da p6-70 (usare fun = p6 >= 70


	instr 13

ileft	=	p9
iright	=	1-p9

ibas	table p6-70, 69

kamp	linen		p4, p7, p3, p8
a1	loscil3		kamp, p5, p6, ibas, 1
a2	loscil3		kamp, p5+p11, p6, ibas, 1
;a3	loscil3		kamp, p5+p11*2, p6, ibas
;a4	loscil3		kamp, p5+p11*3, p6, ibas
aout	=		a1 + a2


	if	p10 > 0 goto afilt
	outs		aout*ileft,aout*iright
	goto	aend
afilt:
gafilt	=	gafilt + aout * p10
aend:
	endin


;	I30	FOF 3 formants
; p4-p5	ampiezze
; p7	freq
; p8-10	formanti
; p11	bw
; p12	attacco
; p13	decay
; p14	estensione vibrato (in +-hz)
; p15	stereo
; NB	usa fun 1 (sine) 40 (sigmoid)

	instr	30

ileft	=	p15
iright	=	1-p15

k1      oscil   p14, 4, 41
a1      fof	p4, p7, p8, 0, p11+k1, .003, .02, .005, 100, 41, 40, p3
a2      fof     p5, p7, p9, 0, p11+k1, .003, .02, .005, 100, 41, 40, p3
a3      fof     p6, p7, p10, 0, p11+k1, .003, .02, .005, 100, 41, 40, p3
kamp	linen	1, p12, p3, p13
aout	=	(a1 + a2 + a3) * kamp

	outs		aout*ileft,aout*iright
	endin



	instr	32				; little chorus on looped wave + delay
ileft	=	p11
iright	=	1-p11
ifbase	table	p6-1, 20
iamp	=	p4/2

asig1	loscil	1, p5, p6, ifbase
asig2	loscil	1, p5+p7, p6, ifbase
asig3	loscil	1, p5+p7*2, p6, ifbase
asig4	loscil	1, p5+p7*3, p6, ifbase
kamp	linseg	0, p8, iamp, p9-p8-p10, iamp, p10, 0, p3-p9, 0
aout1	=	(asig1+asig2+asig3+asig4)*kamp

adel	delayr		p12
	delayw		(adel+aout1)*p13
kramp	linen		1, .01, p3, p10
aout	=		(adel+aout1)*kramp
	outs		aout*ileft,aout*iright
	endin


;	I90	3 bp filters


	instr	90

ileft	=	p11
iright	=	1-p11

a1	butterbp	gafilt, p5, p8
a2	butterbp	gafilt, p6, p9
a3	butterbp	gafilt, p7, p10
aout	=		(a1 + a2 + a3) * p4

	outs		aout*ileft,aout*iright
	endin
